*Avai - Assistente Virtual Acessvel Inteligente;
*Conversor online de texto para fala;
*Por Fabiano Ferreira;
*Em 30/03/2024;

chama @inicia
chama @executa
Escreve "At logo"
termina mudo
*---------------------------*

*Procedimentos;

*--*Inicia o programa;
@inicia

chama @checadiravai
dir troca $diravai

chama @get_openai_apikey
Escreve "Avai-TPF - Conversor de texto para fala."
retorna

*--*Executa enquanto quiser converter arquivos;
@executa
seja $arqresult ""
Escreve "Nome do arquivo de texto a converter"
le $aconverter

busca b $aconverter
se b = ""
Escreve "Arquivo no encontrado."
Escreve "Verifique o nome do arquivo digitado e tente outra vez."
desvia @executa
fim se

chama @escolhevoz
menu termina

Escreve ""
Escreve "Gerando udio, aguarde."
chama @convtexto
se $converteu = 0 desvia @querconvertermais
busca b $arqresult
se b = ""
Escreve "Houve algum erro ao gerar o udio."
Escreve "Nenhum arquivo de resultado foi achado."
escreve "O programa ser encerrado."
espera 1
termina mudo
fim se

Escreve "Concludo. Salvo em "$arqresult
chama @player_interno

@querconvertermais
Escreve "Deseja converter outro arquivo?
le mudo o &
se o = "s" desvia @executa
se o = "n" retorna
desvia @querconvertermais
*

*--*Escolhe uma voz para gerar o udio;
@escolhevoz
menu cria 1 1 40 6
menu adiciona "alloy"
menu adiciona "echo"
menu adiciona "fable"
menu adiciona "onyx"
menu adiciona "nova"
menu adiciona "shimmer"

@fixomenuescolhevoz
Escreve "Escolha a voz que deseja usar"
menu executa n l $voz
se n = 0 desvia @fixomenuescolhevoz
se l = "#27" termina mudo
se l = "#13" retorna
desvia @fixomenuescolhevoz

*--*Obtem e converte o texto para udio;
@convtexto
seja $converteu 0
seja $tammax 0
seja $arqpostdata "temp\pd"
seja $post_data "{""model"": ""tts-1-hd"",""input"":"""

abre #1 $aconverter
le #1 l
checa c
enquanto c = 0

ansiparautf8 l
substitui l "\" "\\"
substitui l """" "\"""
seja t tamanho l
seja $tammax ($tammax + t)
se $tammax > 4096
*A string a ser convertida no pode ter comprimento maior que 4096.
Escreve "O texto enviado no pode ultrapassar a 4096 caracteres."
Escreve ""
escreve "A operao ser cancelada"
fecha #1
retorna
fim se

concatena $post_data l
concatena $post_data "\n"
le #1 l
checa c
fim enquanto
fecha #1

concatena $post_data """,""voice"":"""
concatena $post_data $voz
concatena $post_data """}"

remove $arqpostdata &
abre #1 $arqpostdata &
escreve #1 $post_data
fecha #1

seja z $aconverter
seja p pos "\" z
enquanto p > 0
soma p 1
seja t tamanho z
copia z z p t
seja p pos "\" z
fim enquanto
seja $arqresult "mp3\"
concatena $arqresult z
seja p pos "." $arqresult
se p > 0
seja t tamanho $arqresult
copia z $arqresult t t
enquanto z <> "."
subtrai t 1
copia z $arqresult t t
fim enquanto
subtrai t 1
copia $arqresult $arqresult 1 t
concatena $arqresult ".mp3"

seja $comando "wget -O """
concatena $comando $arqresult
concatena $comando """ --post-file="
concatena $comando $arqpostdata
concatena $comando " --header=""Content-Type: application/json"" --header=""Authorization: Bearer "
concatena $comando $openai_apikey
concatena $comando """ https://api.openai.com/v1/audio/speech"

executa $comando &&

espera 1

existeprog "wget.exe" x
enquanto x = 1
espera 1
bipa 1
existeprog "wget.exe" x
fim enquanto
seja $converteu 1
retorna

*---------------------------*

*Rotinas de Instalao

*--*Obtem o diretrio do perfil de usurio
@obtem_userprofile
seja $arqlog "result.log"
seja $obtemuserprofile "obtemuserprofile.bat"

remove $obtemuserprofile &
abre #1 $obtemuserprofile &
escreve #1 "@echo off"
escreve #1 "chcp 1252"
escreve #1 "echo %userprofile%>"$arqlog" 2>&1"
escreve #1 "exit"
fecha #1

seja $comando $obtemuserprofile
executa $comando &&
espera 1
seja $esperacmd 0
existeprog "cmd.exe" x
enquanto x = 1
se $esperacmd = 20 desvia @para_de_esperar_cmd
soma $esperacmd 1
espera ms 500
existeprog "cmd.exe" x
fim enquanto
@para_de_esperar_cmd
*abandona o loop e continua executando.

busca b $arqlog
enquanto b = ""
espera ms 500
busca b $arqlog
fim enquanto

abre #1 $arqlog
le #1 $userprofile
fecha #1
seja $userprofile trim $userprofile
remove $arqlog
remove $obtemuserprofile
retorna

*--*permite colocar o diretrio avai em qualquer local.
@checadiravai
chama @obtem_userprofile
seja $avaidir $userprofile
concatena $avaidir "\avai.dir"
busca b $avaidir
se b = ""
busca $diravai dir

abre #1 $avaidir &
escreve #1 $diravai
fecha #1
chama @cria_reg_dosvox_ini
seno
abre #1 $avaidir
le #1 $diravai
fecha #1
fim se
retorna

*--*Cria uma entrada no dosvox.ini para facilitar a abertura do programa.
@cria_reg_dosvox_ini
Escreve "Criando entrada no Dosvox.ini."
Escreve "Da prxima vez, voc poder abrir o Avai pressionando r, z, i"
seja $arqatu $diravai
concatena $arqatu "\avai.atu"
remove $arqatu &
abre #1 $arqatu &
escreve #1 "[PROGREDE]"
escreve #1 "Rede23=Z,[PROGSANFER],-RPRGSAN,Programas do portal Sanfer Site"
escreve #1 ""
escreve #1 "[PROGSANFER]"
escreve #1 "Rede8=I,"$diravai"\AVAI.EXE,-REDEIA,Ferramentas de inteligncia artificial"
fecha #1
chama @obtemdirdosvox
seja $comando $dirdosvox
concatena $comando "\atuvox.exe """
concatena $comando $arqatu
concatena $comando """"
executa $comando &
espera 1
existeprog "atuvox.exe" x
enquanto x = 1
espera ms 500
existeprog "atuvox.exe" x
fim enquanto
espera 1
remove $arqatu &
retorna

*--*Obtem o diretrio padro de instalao do Dosvox;
@obtemdirdosvox
seja $dosvoxini $userprofile
concatena $dosvoxini "\appdata\roaming\dosvox\dosvox.ini"
abre #1 $dosvoxini
le #1 $dirdosvox
enquanto no $dirdosvox =* "PGMDOSVOX="
le #1 $dirdosvox
fim enquanto
fecha #1
seja t tamanho $dirdosvox
copia $dirdosvox $dirdosvox 11 t
retorna
*----------------------------*

*Rotina de player interno;

*Pequeno player em scriptvox 5;
*Por Fabiano Ferreira;

@player_interno
seja $tocando 0

handle $handle
seja $cima "#0#72"
seja $baixo "#0#80"
seja $esquerda "#0#75"
seja $direita "#0#77"
seja $enter "#13"
seja $home "#0#71"
seja $end "#0#79"
seja $espaco " "
seja $ponto "."
seja $esc "#27"
seja $f1 "#0#59"
seja $f7 "#0#65"

chama @miniplay.cmd
se $tocando = 0 retorna
@comandosplayerinterno
le mudo $opcao &
se $opcao = $f1 chama @ajudaplayerinterno
se $opcao = $cima chama @aumentavolume
se $opcao = $baixo chama @abaixavolume
se $opcao = $esquerda chama @voltar
se $opcao = $direita chama @avancar
se $opcao = $home chama @inicmusica
se $opcao = $end chama @fimmusica
se $opcao = $espaco chama @playpause
se $opcao = $ponto chama @parar
se $opcao = $esc
 chama @fecha_player_interno
retorna
fim se
desvia @comandosplayerinterno

@miniplay.cmd
seja $volumecentral 1000
seja $volumedireito 1000
seja $volumeesquerdo 1000

@inicia
seja $cmdmci "open ""mpegvideo!"
concatena $cmdmci $arqresult
concatena $cmdmci """ alias musica"

chama @fecha_player_interno
mci r $cmdmci
se r <> 1
escreve "No consegui carregar o contedo solicitado: " $url
retorna
fim se

*evita reproduzir vdeos em janela separada;
seja $mcijanela "window musica handle "
concatena $mcijanela $handle
mci w $mcijanela

mci $tocando "play musica"
seja $tocando 1
seja $playerinternoativo 1
mci $tempomusica "status musica length"
retorna

@voltar
chama @vesetocando
se r = "" retorna
seja r maiusc r
mci $posmusica "status musica position"
se $posmusica > 5000
subtrai $posmusica 5000
seno
seja $posmusica 1
fim se
seja $voltamusica "seek musica to "
concatena $voltamusica $posmusica
mci r $voltamusica
mci $tocando "play musica"
seja $tocando 1
retorna

@avancar
chama @vesetocando
se r = "" retorna
mci $posmusica "status musica position"
soma $posmusica 5000
seja $avancamusica "seek musica to "
concatena $avancamusica $posmusica
mci r $avancamusica
mci $tocando "play musica"
seja $tocando 1
retorna

@parar
chama @vesetocando
se r = "" retorna
seja $tocando 0
mci $parado "stop musica"
seja $parado 1
retorna

@playpause
chama @vesetocando
se r = "" retorna
se $tocando = 1
 mci $posmusica "status musica position"
mci $pausado "pause musica"
seja $parado 0
seja $tocando 0
seno
seja $retoma "play musica"
se $parado = 1 seja $posmusica 1
se $posmusica > 0 concatena $retoma " from "
se $posmusica > 0 concatena $retoma $posmusica
mci r $retoma
seja $tocando 1
fim se
retorna

@aumentavolume
chama @vesetocando
se r = "" retorna
se $volumecentral < 1000
soma $volumecentral 20
soma $volumeesquerdo 20
soma $volumedireito 20
seja r "setaudio musica left volume to "
concatena r $volumeesquerdo
mci v r
seja r "setaudio musica right volume to "
concatena r $volumedireito
mci v r
fim se
retorna

@abaixavolume
chama @vesetocando
se r = "" retorna
se $volumecentral > 0
subtrai $volumecentral 20
subtrai $volumeesquerdo 20
subtrai $volumedireito 20
seja r "setaudio musica left volume to "
concatena r $volumeesquerdo
mci v r
seja r "setaudio musica right volume to "
concatena r $volumedireito
mci v r
fim se
retorna

@inicmusica
chama @vesetocando
se r = "" retorna
mci r "stop musica"
mci r "play musica from 1"
retorna

@fimmusica
chama @vesetocando
se r = "" retorna
seja $vaparafim $tempomusica
subtrai $vaparafim 4000
mci r "stop musica"
seja f "play musica from "
concatena f $vaparafim
mci r f
retorna

@ajudaplayerinterno
Escreve "Opes do player:"
Escreve "Espao: play/pause."
Escreve "Ponto: Stop."
Escreve "Seta esquerda: recuar 5 segundos."
Escreve "Seta direita: avanar 5 segundos."
escreve "Home: vai para o incio"
escreve "end: vai para o fim"
Escreve "F1: mostrar esta ajuda."
Escreve "Esc: terminar a execuo."
retorna

@fecha_player_interno
mci r "close musica"
seja $playerinternoativo 0
retorna

@vesetocando
mci r "status musica mode"
retorna

*--*Obtem a chave de api;
@get_openai_apikey
seja $fkey $userprofile
concatena $fkey "\avai.key"
busca b $fkey
se b = ""
Escreve "Sua chave de api no foi encontrada."
Escreve "Para usar o Avai, voc precisa obter primeiro uma chave de api."
Escreve "Ela ser usada para acessar os servios de inteligncia artificial da Openai."
Escreve "Para adquirir a sua chave,"
Escreve "acesse o endereo:"
escreve "https://platform.openai.com"
escreve "Se ainda no tiver, crie a sua conta, conect-se e siga as instrues para obter sua chave de api e comprar crditos para o seu consumo."
Escreve "Se voc j tem a sua chave, basta col-la agora e pressionar enter."
bipa
le $openai_apikey
se $openai_apikey = "" termina mudo

abre #1 $fkey &
escreve #1 $openai_apikey
fecha #1
Escreve "Chave gravada."
seno
abre #1 $fkey
le #1 $openai_apikey
fecha #1
fim se
retorna
