*Avai - Assistente Virtual Acessvel Inteligente;
*Programa principal;
*Por Fabiano Ferreira;
*Em 30/03/2024;

*Inicia o programa;
chama @inicia
*Mostra menu de ferramentas;
chama @escolhe_app

*---------------------------*

*Procedimentos;

*--*D a mensagem inicial, inicializa algumas variveis e define constantes;
@inicia
seja $versao "2.0"
chama @checadiravai
dir troca $diravai
chama @get_openai_apikey

Escreve "Avai - Assistente Virtual Acessvel Inteligente Verso "$versao
retorna

*--*Escolhe uma ferramenta avai para executar;
@escolhe_app
seja $avai_chat $diravai
concatena $avai_chat "\avai-chat.exe"

seja $avai_tpf $diravai
concatena $avai_tpf "\avai-tpf.exe"

menu cria 1 1 80 10
menu adiciona "Avai-Chat: Um assistente de bate papo que usa o modelo gpt-4."
menu adiciona "Avai-TPF: Um conversor online de texto para fala."

@fixomenuescolheapp
Escreve "Escolha o aplicativo que deseja executar."
Escreve ""
menu executa n l t
se l = "#27" termina mudo
se l = "#13" chama @exec_prog_escolhido
desvia @fixomenuescolheapp

*--*Executa o programa escolhido
@exec_prog_escolhido
se n = 1 busca b $avai_chat
se n = 2 busca b $avai_tpf

se b = ""
escreve "Programa no encontrado."
retorna
fim se

se n = 1 executa $avai_chat &
se n = 2 executa $avai_tpf &
espera 1
termina mudo

*--*Obtem o diretrio do perfil de usurio
@obtem_userprofile
seja $arqlog "result.log"
seja $obtemuserprofile "obtemuserprofile.bat"

remove $obtemuserprofile &
abre #1 $obtemuserprofile &
escreve #1 "@echo off"
escreve #1 "chcp 1252"
escreve #1 "echo %userprofile%>"$arqlog" 2>&1"
escreve #1 "exit"
fecha #1

seja $comando $obtemuserprofile
executa $comando &&
espera 1
seja $esperacmd 0
existeprog "cmd.exe" x
enquanto x = 1
se $esperacmd = 20 desvia @para_de_esperar_cmd
soma $esperacmd 1
espera ms 500
existeprog "cmd.exe" x
fim enquanto
@para_de_esperar_cmd
*abandona o loop e continua executando.

busca b $arqlog
enquanto b = ""
espera ms 500
busca b $arqlog
fim enquanto

abre #1 $arqlog
le #1 $userprofile
fecha #1
seja $userprofile trim $userprofile
remove $arqlog
remove $obtemuserprofile
retorna

*--*permite colocar o diretrio avai em qualquer local.
@checadiravai
chama @obtem_userprofile
seja $avaidir $userprofile
concatena $avaidir "\avai.dir"
busca b $avaidir
se b = ""
busca $diravai dir

abre #1 $avaidir &
escreve #1 $diravai
fecha #1
chama @cria_reg_dosvox_ini
seno
abre #1 $avaidir
le #1 $diravai
fecha #1
fim se
retorna

*--*Cria uma entrada no dosvox.ini para facilitar a abertura do programa.
@cria_reg_dosvox_ini
Escreve "Criando entrada no Dosvox.ini."
Escreve "Da prxima vez, voc poder abrir o Avai pressionando r, z, i"
seja $arqatu $diravai
concatena $arqatu "\avai.atu"
remove $arqatu &
abre #1 $arqatu &
escreve #1 "[PROGREDE]"
escreve #1 "Rede23=Z,[PROGSANFER],-RPRGSAN,Programas do portal Sanfer Site"
escreve #1 ""
escreve #1 "[PROGSANFER]"
escreve #1 "Rede8=I,"$diravai"\AVAI.EXE,-REDEIA,Ferramentas de inteligncia artificial"
fecha #1
chama @obtemdirdosvox
seja $comando $dirdosvox
concatena $comando "\atuvox.exe """
concatena $comando $arqatu
concatena $comando """"
executa $comando &
espera 1
existeprog "atuvox.exe" x
enquanto x = 1
espera ms 500
existeprog "atuvox.exe" x
fim enquanto
espera 1
remove $arqatu &
retorna

*--*Obtem o diretrio padro de instalao do Dosvox;
@obtemdirdosvox
seja $dosvoxini $userprofile
concatena $dosvoxini "\appdata\roaming\dosvox\dosvox.ini"
abre #1 $dosvoxini
le #1 $dirdosvox
enquanto no $dirdosvox =* "PGMDOSVOX="
le #1 $dirdosvox
fim enquanto
fecha #1
seja t tamanho $dirdosvox
copia $dirdosvox $dirdosvox 11 t
retorna


*--*Obtem a chave de api;
@get_openai_apikey
seja $fkey $userprofile
concatena $fkey "\avai.key"
busca b $fkey
se b = ""
Escreve "Sua chave de api no foi encontrada."
Escreve "Para usar o Avai, voc precisa obter primeiro uma chave de api."
Escreve "Ela ser usada para acessar os servios de inteligncia artificial da Openai."
Escreve "Para adquirir a sua chave,"
Escreve "acesse o endereo:"
escreve "https://platform.openai.com"
escreve "Se ainda no tiver, crie a sua conta, conect-se e siga as instrues para obter sua chave de api e comprar crditos para o seu consumo."
Escreve "Se voc j tem a sua chave, basta col-la agora e pressionar enter."
bipa
le $openai_apikey
se $openai_apikey = "" termina mudo

abre #1 $fkey &
escreve #1 $openai_apikey
fecha #1
Escreve "Chave gravada."
seno
abre #1 $fkey
le #1 $openai_apikey
fecha #1
fim se
retorna
